/*  $Id: SCBalloonSkin.java,v 1.4 2004/02/05 09:29:34 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import util.*;

public class SCBalloonSkin {
    NSImage image;
    NSRect frame;
    int type; // SCFoundation.HOONTAI or SCFoundation.UNYUU
    int id;
    SCDescription desc;
    
    public SCBalloonSkin(SCDescription parentDesc,File dir,String bskinname,int id,int type) {
	// dir : o[̃fBNg
	// bskinname : Ⴆballoons0balloonk1
	this.id = id;
	this.type = type;
	File pngfile = new File(dir,bskinname+".png");
	if (!pngfile.exists()) return;
	
	image = SCAlphaConverter.convertImage(new NSImage(pngfile.getPath(),true));
	frame = new NSRect(NSPoint.ZeroPoint,image.size());
		
	desc = new SCDescription(parentDesc,new File(dir,bskinname+"s.txt"));
	//desc.setTag(dir.toString());
    }
    
    public NSImage getImage() {
	return image;
    }
    
    public NSRect getFrame() {
	return frame;
    }
    
    public int getID() {
	return id;
    }
    
    public int getType() {
	return type;
    }
    
    public SCDescription getDescription() {
	return desc;
    }

    public String toString() {
	StringBuffer buf = new StringBuffer();
	buf.append("id: ").append(id);
	buf.append("; type: ").append(type);
	return buf.toString();
    }

    protected void finalize() {
	//Logger.log(this, Logger.DEBUG, "finalized");
    }
}
