/*
    $Id: SCBlockedDescription.java,v 1.8 2003/10/27 13:16:21 phonohawk Exp $
    ----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.util.*;

public class SCBlockedDescription {
    Hashtable root; // key : (String)L[ , content : (String)l or (Vector)l̏W
    
    public SCBlockedDescription() {
	// ̃IuWFNg쐬B
	root = new Hashtable();
    }
    
    public SCBlockedDescription(File f) {
	// t@CǂݍށB
	// ݂Ȃ΋̃IuWFNg쐬B
	root = new Hashtable();
	if (f.exists()) {
	    try {
		new Parser(root,new FileInputStream(f)).parse();
	    }
	    catch (Exception e) {
		System.err.println("load failed: "+f.getAbsolutePath());
		e.printStackTrace();
	    }
	}
    }
    
    public SCBlockedDescription(InputStream is) {
	// Xg[ǂݍށB
	root = new Hashtable();
	try {
	    new Parser(root,is).parse();
	}
	catch (Exception e) {
	    System.err.println("load failed");
	    e.printStackTrace();
	}
    }
    
    public Object get(String key) {
	// Ԃ̂StringVector̂ǂ炩łB
	return root.get(key);
    }
    
    public boolean exists(String key) {
	return (root.get(key) != null);
    }

    public boolean isBlock(String key) {
	Object obj = root.get(key);
	return obj != null && obj instanceof Vector;
    }
    
    public Enumeration keys() {
	return root.keys();
    }
    
    public Enumeration elements() {
	return root.elements();
    }
	
    protected class Parser {
	Hashtable root;
	
	Vector overread;
	BufferedReader br;
	
	public Parser(Hashtable root,InputStream is) throws Exception {
	    this.root = root;
	    
	    overread = new Vector(); // ǂ݉߂s
	    br = new BufferedReader(new InputStreamReader(is,"SJIS"));
	}
	
	protected String nextLine() throws Exception {
	    String line;
	    if (overread.size() > 0) {
		line = (String)overread.elementAt(0);
		overread.remove(0);
	    }
	    else {
		line = br.readLine();
	    }
	    return line;
	}
	
	protected void rollBack(String line) {
	    if (line != null) {
		overread.add(0,line);
	    }
	}
	
	public void parse() throws Exception {
	    while (true) {
		String line = nextLine();
		if (line == null) break; // eof
		line = line.trim();
		if (line.length() == 0) continue; // ̍s͖B
		if (line.startsWith("//")) continue; // Rgs͖B
		
		Vector entryname = new Vector();
		
		if (line.indexOf(',') != -1) { // PsGgۂ
		    // ̍su{vGgB
		    // łȂΒPsGgB
		    String next = nextLine();
		    // ǂ݉߂̂Ŋ߂
		    rollBack(next);
		    
		    if (next != null && next.trim().equals("{")) {
			StringTokenizer entries = new StringTokenizer(line,",");
			while (entries.hasMoreTokens()) {
			    entryname.add(entries.nextToken());
			}
		    }
		    else {
			int commapos = line.indexOf(',');
			String key = line.substring(0,commapos);
			String value = line.substring(commapos+1);
			root.put(key,value);
			continue;
		    }
		}
		else {
		    entryname.add(line);
		}
		
		// PsłȂΕsɓnGgȂ̂
		// uX̎n܂肩I܂łǂݍށB
		Vector elements = new Vector();

		try {
		    if (!nextLine().trim().equals("{")) break; // uXŎn܂ĂȂ΃G[B
		} catch (NullPointerException e) {
		    break;
		}
		while (true) {
		    String inner_line = nextLine();
		    if (inner_line == null) break; // ubNIOEOFɒBBG[B
		    if (inner_line.length() == 0) continue; // ̍s͖B
		    if (inner_line.startsWith("//")) continue; // Rgs͖B
		    if (inner_line.trim().equals("}")) break; // ubNɏIB
		    
		    elements.add(inner_line);
		}
		
		for (Enumeration e = entryname.elements(); e.hasMoreElements(); ) {
		    root.put(e.nextElement(),elements);
		}
	    }
	    br.close();
	}
    }
}
