/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class SCNSConditionEntries
{
    SCNiseShiori niseshiori;
    
    Vector array;
    // ev́reGg̃XgłBgSCNSConditionEntryłB
    
    public SCNSConditionEntries(SCNiseShiori niseshiori)
    {
	this.niseshiori = niseshiori;
	array = new Vector();
    }
    
    public void addEntry(String condition,String script)
    {
	array.add(new SCNSConditionEntry(condition,script));
    }
    
    public Vector findEntries(String stringToMatch)
    {
	// ev́reGg̒w肳ꂽCxg^Cv̓ZeXɃ}b`Gg
	// SĕԂ܂BSCNSConditionEntryłB
	Vector result = new Vector();
	
	int n_elems = array.size();
	for (int i = 0;i < n_elems;i++)
	{
	    // &ŋ؂Ă܂B
	    SCNSConditionEntry current_ev = (SCNSConditionEntry)array.elementAt(i);
	    if (niseshiori.getJudgement().judge(current_ev.condition(),stringToMatch))
	    {
		result.add(current_ev);
	    }
	}
	
	return result;
    }
    
    public static Vector pickupMaxPriority(Vector in)
    {
	// content of in : (SCNSConditionEntry)
	// łD揇ʂGg̃XgԂ܂B
	
	// ܂Max߂
	int max = 0;
	Enumeration maxphase = in.elements();
	while (maxphase.hasMoreElements())
	{
	    int p = ((SCNSConditionEntry)maxphase.nextElement()).priority();
	    if (p > max) max = p;
	}
	
	// ̗D揇ʂڂsbNAbv
	Vector result = new Vector();
	Enumeration pickupphase = in.elements();
	while (pickupphase.hasMoreElements())
	{
	    SCNSConditionEntry current = (SCNSConditionEntry)pickupphase.nextElement();
	    if (current.priority() == max)
	    {
		result.add(current);
	    }
	}
	return result;
    }
}
