/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class SCNSJudgement
{
    SCNiseShiori niseshiori;
    
    public SCNSJudgement(SCNiseShiori niseshiori)
    {
	this.niseshiori = niseshiori;
    }
    
    public boolean judge(String condition,String stringToMatch)
    {
	// stringToMatchɂ͉Zq̃g[Nł̃}b`OɎgw肵ĉB
	// ̔肪SĐ^ɂȂtrueԂ܂B
	boolean hit = true;
	stringToMatch = stringToMatch.toLowerCase();
	StringTokenizer st = new StringTokenizer(evaluateMacro(condition.toLowerCase()),"&");
	while (st.hasMoreTokens() && hit)
	{
	    String token = st.nextToken().trim();
	    
	    try
	    {
		int pos;
		if ((pos = token.indexOf(">=")) != -1)
		{
		    int left = Integer.parseInt( niseshiori.getSysVars().get(token.substring(1,pos)) );
		    int right = Integer.parseInt( token.substring(pos+2) );
		    hit = (left >= right);
		}
		else if ((pos = token.indexOf("<=")) != -1)
		{
		    int left = Integer.parseInt( niseshiori.getSysVars().get(token.substring(1,pos)) );
		    int right = Integer.parseInt( token.substring(pos+2) );
		    hit = (left <= right);
		}
		else if ((pos = token.indexOf("<>")) != -1)
		{
		    try
		    {
			int left = Integer.parseInt( niseshiori.getSysVars().get(token.substring(1,pos)) );
			int right = Integer.parseInt( token.substring(pos+2) );
			hit = (left != right);
		    }
		    catch (NumberFormatException e)
		    {
			String left = niseshiori.getSysVars().get(token.substring(1,pos));
			String right = token.substring(pos+2);
			hit = (!left.equals(right));
		    }
		}
		else if ((pos = token.indexOf('>')) != -1)
		{
		    int left = Integer.parseInt( niseshiori.getSysVars().get(token.substring(1,pos)) );
		    int right = Integer.parseInt( token.substring(pos+1) );
		    hit = (left > right);
		}
		else if ((pos = token.indexOf('<')) != -1)
		{
		    int left = Integer.parseInt( niseshiori.getSysVars().get(token.substring(1,pos)) );
		    int right = Integer.parseInt( token.substring(pos+1) );
		    hit = (left < right);
		}
		else if ((pos = token.indexOf('=')) != -1)
		{
		    try
		    {
			int left = Integer.parseInt( niseshiori.getSysVars().get(token.substring(1,pos)) );
			int right = Integer.parseInt( token.substring(pos+1) );
			hit = (left == right);
		    }
		    catch (NumberFormatException e)
		    {
			String left = niseshiori.getSysVars().get(token.substring(1,pos));
			String right = token.substring(pos+1);
			hit = (left.equals(right));
		    }
		}
		else if (stringToMatch.indexOf(token) == -1)
		{
		    hit = false;
		}
	    }
	    catch (Exception e)
	    {
		hit = false;
	    }
	}
	return hit;
    }
    
    private String evaluateMacro(String str)
    {
	StringBuffer buf = new StringBuffer(str);
	
	int pos = 0;
	while (pos < buf.length())
	{
	    if (buf.charAt(pos) != '@') { pos++; continue; }
	    
	    if (buf.toString().toLowerCase().startsWith("@sakura",pos))
	    {
		buf.replace(pos,pos+7,"%ref3=0");
	    }
	    else if (buf.toString().toLowerCase().startsWith("@kero",pos))
	    {
		buf.replace(pos,pos+5,"%ref3=1");
	    }
	    else if (buf.toString().toLowerCase().startsWith("@nomail",pos))
	    {
		buf.replace(pos,pos+7,"%ref0=0");
	    }
	    else
	    {
		pos++;
	    }
	}
	
	return buf.toString();
    }
}
