/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

public class SCNSWord
{
    String word;
    String category,type;
    SCNSWord chain_target; // `FC̑΂ɂȂЕBWordToWord`FCłȂnullB
    int prob; // ImB1ŒiftHgjB
    
    public SCNSWord(String category,String type,String word)
    {
	this.category = category;
	this.type = type;
	this.word = word;
	this.chain_target = null;
	this.prob = 1;
    }
    
    public SCNSWord(String word,SCNSWord chain_target)
    {
	this.category = category;
	this.type = type;
	this.word = word;
	this.chain_target = chain_target;
	this.prob = 1;
    }
    
    public String getCategory() {return category;}
    public String getType() {return type;}
    public String getWord() {return word;}
    public int getProb() {return prob;}
    public SCNSWord getChainTarget() {return chain_target;}
    public void setChainTarget(SCNSWord targ) {chain_target = targ;}
    public void setProb(int p) {prob = (p >= 1 ? p : 1);}
    public void incProb(int d)
    {
	prob += d;
    }
    public void decProb(int d)
    {
	prob = (prob - d >= 1 ? prob - d : 1);
    }
}
