/*  $Id: SCScriptRunner.java,v 1.28 2004/02/05 09:48:38 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.net.URL;
import java.util.*;
import java.lang.reflect.Method;
import util.*;

public class SCScriptRunner extends Thread {
    public static final int DEFAULT_ALTERNATIVE_TIMEOUT_SEC = 20;
    
    SCSession session;
    StringBuffer script;
    String master_script;
    String curHandlerName; // ݎs̃nh̖OBUAȈꍇŃnh݂ȂꍇnullB
    
    // IvV
    
    // \s^Og킸ɒ낤Ƃ狭I\s[0]܂\s[10]sB
    // IvV"force-reset-surfaces-before-talk"ŁA^BooleanB
    boolean force_reset_surfaces_before_talk = false;
    // ǂ炩낤ƂȂ܂\s^OgĂȂÃVF\B
    // IvV"show-partner-before-talk-if-not-used-yen-s"ŁA^BooleanB
    boolean show_partner_before_talk_if_not_used_yen_s = false;
    // URLłȂII΂ꂽAo[ȊO̎ȂB
    // IvV"do-nothing-but-close-when-normal-alternative-selected"ŁA^BooleanB
    boolean do_nothing_but_close_when_normal_alternative_selected = false;
    
    volatile boolean interrupt_forbidden = false;
    volatile boolean flagTerm = false;
    int wait;
    boolean quicksession = false;
    boolean synchronizedsession = false;
    boolean changedBalloon = false;
	
    static volatile double wait_ratio = 1.0; // \w\_w̔{B
    
    volatile boolean speed_up = false;
    double speed_up_ratio = 0.1;
    
    int scope = 0; // ݂̃XR[vB[Ȃ{́A1Ȃ炤ɂイB
    boolean enyee = false; // 񂢁[ɒBǂB
    boolean sakura_yen_s_used = false; // ܂łsakuraXR[v\sgꂽB
    boolean kero_yen_s_used = false; // keroXR[v

    Set unselected_urls = null; // [SCBalloonAlternative] ܂IĂȂURLB
    
    public static final int RUNNING = 1; // sB
    public static final int SCRIPT_END = 2; // XNvgĐIB
    public static final int DONE = 3; // XNvgĐI莞Ԃo߂Bi܂Xbh͏IɃEChEJĂj
    // ͑IIꂽB
    public static final int TERMINATED = 4; // DONEɂȂOterminate()ꂽB
    private volatile int status = RUNNING;
    
    private volatile int alternative_timeout_sec = DEFAULT_ALTERNATIVE_TIMEOUT_SEC;
    private volatile boolean hasAlternative = false; // IꍇtrueɂȂ܂B
    private volatile SCBalloonAlternative selectedAlt = null; // IꍇAstatusDONEɂȂɑIꂽI܂B
    // ^CAEgꍇnull̂܂܂łB
    
    public SCScriptRunner(SCSession s,String param,Hashtable options) {
	this(s,param);
	if (options == null) return;
	
	Boolean frsbt = (Boolean)options.get("force-reset-surfaces-before-talk");
	if (frsbt != null && frsbt.booleanValue()) {
	    force_reset_surfaces_before_talk = true;
	}
	
	Boolean spbtinuys = (Boolean)options.get("show-partner-before-talk-if-not-used-yen-s");
	if (spbtinuys != null && spbtinuys.booleanValue()) {
	    show_partner_before_talk_if_not_used_yen_s = true;
	}

	Boolean dnbcwnas = (Boolean)options.get("do-nothing-but-close-when-normal-alternative-selected");
	if (dnbcwnas != null && dnbcwnas.booleanValue()) {
	    do_nothing_but_close_when_normal_alternative_selected = true;
	}
    }
    public SCScriptRunner(SCSession s,String param) {
	// sɂ͌ݗLȃZbVnĂB
	// param#Ŏn܂Ă炻̃GgTAłȂparamXNvgƂĂ̂܂܎s܂B
	wait = 40;
        session = s;
        quicksession = interrupt_forbidden = changedBalloon = false;
        
        if (param.charAt(0) == '#') {
            curHandlerName = param;
	    
	    String new_entry = session.getTempScriptServer().findEntry(param);
	    if (new_entry == null) {
		script = new StringBuffer("\\h\\s[4]Handler \""+param+"\" was not found...\\e");
		return;
	    }
            
            script = new StringBuffer(new_entry);
        }
        else {
            script = new StringBuffer(param);
        }

	// obNXbVɒu
	if (script.toString().indexOf('\\') != -1) {
	    int pos;
	    while ((pos = script.toString().indexOf('\\')) != -1) {
		script.setCharAt(pos,'\u00a5');
	    }
	}

	// \t\q܂ރXNvg̓C^vg֎~B
	//if (script.toString().indexOf("\u00a5t") != -1 ||
	//    script.toString().indexOf("\u00a5q") != -1) {
	//    interrupt_forbidden = true;
	//}
    }
    
    public void run() {
	int pool = NSAutoreleasePool.push();
	
	master_script = script.toString();
	
	session.getHontaiBalloon().hide();
	session.getUnyuuBalloon().hide();
	session.getHontaiBalloon().cleanUp();
	session.getUnyuuBalloon().cleanUp();
	session.getHontaiBalloon().setCallbackTarget(this);
	session.getUnyuuBalloon().setCallbackTarget(this);
	
	try {
	    while(!enyee && !flagTerm && script.length() > 0) { // 񂢁[ɒBAC^vgꂽAsׂc̃XNvgȂ肵IB
		/*
		  XNvgǂŏsB
		  ^Oϐ͈āȂ̕i\j͂܂邲ƈɂB
		*/
		char firstchar = script.charAt(0);
		/*char secondChar;
		  char thirdChar;*/
		switch (firstchar) {
		case	'\u00a5': {
		    // ɑ%GXP[vĕ\B
		    char secondChar = script.charAt(1);
		    if (secondChar == '\u00a5' || secondChar == '%') {
			String escaped = script.substring(1,2);
			script.delete(0,2); // 擪̓񕶎B
			
			SCShellWindowController swc = (scope == 0 ? session.getHontai() : session.getUnyuu());
			swc.show();
			
			if (synchronizedsession) {
			    session.getHontaiBalloon().show();
			    session.getUnyuuBalloon().show();
			    session.getHontaiBalloon().addText(escaped,0);
			    session.getUnyuuBalloon().addText(escaped,quicksession ? 0 : wait);
			}
			else {
			    SCSafetyBalloonController bc = (scope == 0 ? session.getHontaiBalloon() : session.getUnyuuBalloon());
			    bc.show();
			    bc.addText(escaped,quicksession ? 0 : wait);
			}
		    }
		    else {
			// Ŏn܂^OB
			switch (secondChar) {
			case	'e': // 񂢁[
			    script.setLength(0);
			    enyee = true;
			    break; // ŏIB
			    
			case	'a': // random talk
			    status = DONE;
			    script.setLength(0);
			    interrupt_forbidden = false;
			    enyee = true;
			    session.doShioriRandomTalk();
			    NSAutoreleasePool.pop(pool);
			    return;
			    
			case	'-': // I
			    script.setLength(0);
			    enyee = true;
			    break;
			    
			case	'+': // S[Xg_`FW
			    script.setLength(0);
			    enyee = true;
			    session.changeToOtherGhostAtRandom();
			    break;
			    
			case	'h': // {̃XR[v
			case	'0':
			    scope = 0;
			    script.delete(0,2); // 擪̓񕶎Bc肪oB
			    break;
			    
			case	'u': // ɂイXR[v
			case	'1':
			    scope = 1;
			    script.delete(0,2);
			    break;
			    
			case	'4': // JgXR[vׂ̗܂ňړB؂Ȃ悤ɍlB
			case	'5':
			    session.forceMovingNextToAnother(scope == 0 ? SCFoundation.HONTAI : SCFoundation.UNYUU);
			    script.delete(0,2);
			    break;
			    
			case	'n': // JgXR[ṽo[ŉs
			    doReturn(script);
			    break;
			    
			case	't': // ^CNeBJZbVɓ
			    interrupt_forbidden = true;
			    script.delete(0,2);
			    break;
			    
			case	'i': // SERIKOV[PXN
			    executeSerikoSequence(script);
			    break;
			    
			case	's': // JgXR[ṽT[tBXύX
			    doSurfaceChanging(script);
			    break;
			    
			case	'w': // EGCg
			    doWaitCommand(script);
			    break;
			    
			case	'b': // o[
			    doBalloonChanging(script);
			    break;
			    
			case	'j': // ̃Gg̓uEUURLɃWv
			    doUniversalJumpCommand(script);
			    break;
			    
			case	'c': { // JgXR[ṽo[NA
			    if (synchronizedsession) {
				//sleep(quicksession ? CLEAR_WAIT_IN_QUICK_SESSION : 0);
				session.getSakuraBalloon().beEmpty();
				session.getKeroBalloon().beEmpty();
			    }
			    else {
				//sleep(quicksession ? CLEAR_WAIT_IN_QUICK_SESSION : 0);
				SCSafetyBalloonController bc = (scope == 0 ? session.getHontaiBalloon() : session.getUnyuuBalloon());
				bc.beEmpty();
			    }
			    script.delete(0,2); // \c̓񕶎B
			}
			    break;
			    
			case	'x': // }EXNbN܂ňꎞ~
			    // łB
			    script.delete(0,2); // \x
			    break;
			    
			case	'!': // ėpR}hV{
			    executeUniversalCommand(script);
			    break;
			    
			case	'_': { // _s,_w[],_q,_e,_c[],_m[],_u[],_c[],_a[]__c,__t̋^
			    if (script.charAt(2) == 's') { // VNiCYhZbV
				synchronizedsession = !synchronizedsession;
				script.delete(0,3);
			    }
			    else if (script.charAt(2) == 'w') { // xEGCg
				doStrictWaitCommand(script);
			    }
			    else if (script.charAt(2) == 'm') { // ASCIIR[hߍ
				doAsciiCodeImplantation(script);
			    }
			    else if (script.charAt(2) == 'u') { // UCS-2R[hߍ
				doUCS2CodeImplantation(script);
			    }
			    else if (script.charAt(2) == 'q') { // NCbNZbV
				quicksession = !quicksession; // toggle
				script.delete(0,3);
			    }
			    else if (script.charAt(2) == 'e') { // ݂̃XR[ṽo[
				SCSafetyBalloonController bc = (scope == 0 ? session.getHontaiBalloon() : session.getUnyuuBalloon());
				bc.hide();
				script.delete(0,3);
			    }
			    else if (script.charAt(2) == 'c') {
				// []ň͂܂ꂽ͈͂GET Sentence With SentenceŃNGXgāAʂ^Oʒuɑ}B
				doShioriCommunicateImplantation(script);
			    }
			    else if (script.charAt(2) == 'a') { // AJ[
				doPuttingAnchor(script);
			    }
                            else if (script.charAt(2) == 'b' ) { // o[C[W\
                                doBalloonImageCommand(script);
                            }
			    else if (script.charAt(2) == '_') { // __c,__t̋^LB
				if (script.charAt(3) == 'c') {
				    session.showCommunicateBox();
				    script.delete(0,4);
				}
				else if (script.charAt(3) == 't') {
				    session.doTeach();
				    script.delete(0,4);
				}
				else {
				    script.delete(0,4);
				}
			    }
			    else {
				script.delete(0,2);
			    }
			}
			    break;
			    
			case	'v': { // tHAOEh
			    NSApplication.sharedApplication().activateIgnoringOtherApps(true);
			    script.delete(0,2);
			}
			    break;
			    
			case	'q': // I
			    doPuttingAlternativeCommand(script);
			    break;
			    
			default: { // `^O
			    script.replace(0,1,"\u00a5\u00a5"); // \\ɂB
			}
			    break;
			} // end switch (secondChar)
		    } // end if (script.charAt(1) == '\u00a5' || script.charAt(1) == '%')
		}
		    break;
		    
		case	'%':
		    char secondChar = script.charAt(1);
		    switch (secondChar) {
		    case	'j': // CN[h
			doHandlerImplantation(script);
			break;
			
		    case	's': { // %selfname,%second,...
			String script_str = script.toString();
			if (script_str.startsWith("%selfname")) {
			    script.replace(0,9,session.getSelfName());
			}
			else if (script_str.startsWith("%second")) {
			    NSGregorianDate gdate = new NSGregorianDate();
			    script.replace(0,7,""+gdate.secondOfMinute());
			}
			else {
			    // B\%ɂB
			    script.replace(0,1,"\u00a5%");
			}
		    }
			break;
			
		    case	'k': { // %keroname
			if (script.toString().startsWith("%keroname")) { // ɂイ̖O
			    script.replace(0,9,session.getKeroName());
			}
			else {
			    // B\%ɂB
			    script.replace(0,1,"\u00a5%");
			}
		    }
			break;
			
		    case	'm': { // %month,%minute,...
			if (script.toString().startsWith("%month")) {
			    NSGregorianDate gdate = new NSGregorianDate();
			    script.replace(0,6,""+gdate.monthOfYear());
			}
			else if (script.toString().startsWith("%minute")) {
			    NSGregorianDate gdate = new NSGregorianDate();
			    script.replace(0,7,""+gdate.minuteOfHour());
			}
			else if (script.toString().startsWith("%ms")) {
			    String word = session.getWordFromShiori("\u00a5ms");
			    script.replace(0,3,(word == null ? "" : word));
			}
			else if (script.toString().startsWith("%mz")) {
			    String word = session.getWordFromShiori("\u00a5mz");
			    script.replace(0,3,(word == null ? "" : word));
			}
			else if (script.toString().startsWith("%mc")) {
			    String word = session.getWordFromShiori("\u00a5mc");
			    script.replace(0,3,(word == null ? "" : word));
			}
			else if (script.toString().startsWith("%mh")) {
			    String word = session.getWordFromShiori("\u00a5mh");
			    script.replace(0,3,(word == null ? "" : word));
			}
			else if (script.toString().startsWith("%mt")) {
			    String word = session.getWordFromShiori("\u00a5mt");
			    script.replace(0,3,(word == null ? "" : word));
			}
			else if (script.toString().startsWith("%me")) {
			    String word = session.getWordFromShiori("\u00a5me");
			    script.replace(0,3,(word == null ? "" : word));
			}
			else if (script.toString().startsWith("%mp")) {
			    String word = session.getWordFromShiori("\u00a5mp");
			    script.replace(0,3,(word == null ? "" : word));
			}
			else if (script.toString().startsWith("%m?")) {
			    String word = session.getWordFromShiori("\u00a5m?");
			    script.replace(0,3,(word == null ? "" : word));
			}
			else {
			    script.replace(0,1,"\u00a5%");
			}
		    }
			break;
			
		    case	'd': { // %day,%dms
			if (script.toString().startsWith("%day")) {
			    NSGregorianDate gdate = new NSGregorianDate();
			    script.replace(0,4,""+gdate.dayOfMonth());
			}
			else if (script.toString().startsWith("%dms")) {
			    String word = session.getWordFromShiori("\u00a5dms");
			    script.replace(0,4,(word == null ? "" : word));
			}
			else {
			    script.replace(0,1,"\u00a5%");
			}
		    }
			break;
			
		    case	'h': { // %hour
			if (script.toString().startsWith("%hour")) {
			    NSGregorianDate gdate = new NSGregorianDate();
			    script.replace(0,5,""+gdate.hourOfDay());
			}
			else {
			    script.replace(0,1,"\u00a5%");
			}
		    }
			break;
			
		    case	'u': { // %username
			if (script.toString().startsWith("%username")) {
			    String username = session.getStringFromShiori("username");
			    if (username == null) {
				script.delete(0,9);
			    }
			    else {
				script.replace(0,9,username);
			    }
			}
			else {
			    script.replace(0,1,"\u00a5%");
			}
		    }
			break;
			
		    case	'e': { // %exh , %et
			if (script.toString().startsWith("%exh")) { // valid
			    script.replace(0,4,Integer.toString(session.hoursFromBootTime()));
			}
			else if (script.toString().startsWith("%et")) { // invalid
			    script.replace(0,3,SCFoundation.pseudoHoursFromStartTime());
			}
			else {
			    script.replace(0,1,"\u00a5%");
			}
		    }
			break;
			
		    default: { // `%^O
			script.replace(0,1,"\u00a5%");
		    }
			break;
		    }
		    break;
		    
		default: // R[hłȂ
		    // ɃGXP[vĂȂ%܂ŁA̓XNvg̏IɒB܂ł𒼐ڕ\ubNƂB
		    int script_len = script.length();
		    int blockend = 0;
		    while (blockend <= script_len - 1) {
			if (script.charAt(blockend) == '\u00a5') {
			    if (script_len - 1 > blockend) {
				if (script.charAt(blockend + 1) == '\u00a5' || script.charAt(blockend + 1) == '%') {
				    script.deleteCharAt(blockend);
				    script_len--;
				}
				else {
				    blockend--;
				    break;
				}
			    }
			    else {
				blockend--;
				break;
			    }
			}
			else if (script.charAt(blockend) == '%') {
			    blockend--;
			    break;
			}
			
			// \Ȃ̂ŃT[`𑱂
			blockend++;
		    }
		    if (blockend > script_len - 1) blockend = script_len - 1;
		    String block = script.substring(0,blockend + 1);
		    script.delete(0,blockend + 1);
		    
		    if (synchronizedsession) { // VNiCYhZbV
			session.getSakura().show();
			session.getKero().show();
			
			if (force_reset_surfaces_before_talk) {
			    // ƂKvȂ珉B
			    if (!sakura_yen_s_used) {
				script.insert(0,"\u00a5s[0]");
				
				int scope_backup = scope;
				scope = 0;
				doSurfaceChanging(script);
				scope = scope_backup;
			    }
			    if (!kero_yen_s_used) {
				script.insert(0,"\u00a5s[10]");
				
				int scope_backup = scope;
				scope = 1;
				doSurfaceChanging(script);
				scope = scope_backup;
			    }
			}
			
			SCSafetyBalloonController hbal = session.getHontaiBalloon();
			SCSafetyBalloonController ubal = session.getUnyuuBalloon();
			hbal.show();
			ubal.show();
			
			int n_chars = block.length();
			for (int i = 0;i < n_chars;i++) {
			    hbal.addChar(block.charAt(i));
			    ubal.addChar(block.charAt(i));
			    
			    sleep(quicksession ? 0 : (long)(wait * (speed_up ? speed_up_ratio : 1) * wait_ratio));
			}
		    }
		    else if (scope == 0) { // {
			session.getSakura().show();
			
			if (force_reset_surfaces_before_talk) {
			    // KvȂ珉
			    if (!sakura_yen_s_used) {
				script.insert(0,"\u00a5s[0]");
				doSurfaceChanging(script);
			    }
			}
			
			if (show_partner_before_talk_if_not_used_yen_s) {
			    // KvȂ\
			    if (!kero_yen_s_used) {
				script.insert(0,"\u00a5s[10]");
				scope = 1; doSurfaceChanging(script); scope = 0;
				session.getKero().show();
			    }
			}
			
			session.getHontaiBalloon().show();
			session.getHontaiBalloon().addText(
			    block,
			    quicksession ? 0 : (long)(wait * (speed_up ? speed_up_ratio : 1) * wait_ratio));
		    }
		    else if (scope == 1) { // ɂイ
			session.getKero().show();
			
			if (force_reset_surfaces_before_talk) {
			    // KvȂ珉
			    if (!kero_yen_s_used) {
				script.insert(0,"\u00a5s[10]");
				doSurfaceChanging(script);
			    }
			}
			
			if (show_partner_before_talk_if_not_used_yen_s) {
			    // KvȂ\
			    if (!sakura_yen_s_used) {
				script.insert(0,"\u00a5s[0]");
				scope = 0; doSurfaceChanging(script); scope = 1;
				session.getSakura().show();
			    }
			}
			
			session.getUnyuuBalloon().show();
			session.getUnyuuBalloon().addText(
			    block,
			    quicksession ? 0 : (long)(wait * (speed_up ? speed_up_ratio : 1) * wait_ratio));
		    }
		} // switch (firstchar)
	    } // while(!isInterrupted() && script.length() > 0)
	} // try
	catch (InterruptedException e) {
	    flagTerm = true;
	}
	catch (SCScriptErrorException e) {
	    System.err.println("SCScriptRunner : Script Error.");
	    System.err.println("   "+e.getMessage());
	    System.err.println(" : "+master_script);
	}
	catch (Exception e) {
	    System.err.println("SCScriptRunner : Exception occured in running script.");
	    e.printStackTrace();
	}
	
	if (flagTerm) {
	    status = TERMINATED;
	}
	else {
	    status = SCRIPT_END;
	    
	    if (hasAlternative) {
		boolean interrupted = false;
		// ^CAEgԂ͓rŝ̂͂\B
		long wait_start = System.currentTimeMillis();
		while (true) {
		    if (System.currentTimeMillis() - wait_start > alternative_timeout_sec * 1000) {
			break;
		    }
		    try {
			sleep(1000);
		    } catch (InterruptedException e) {
			interrupted = true; // IꂽA͒PɃC^vgꂽB
			break;
		    }
		}
		
		if (interrupted && selectedAlt == null) {
		    // PɃC^vgꂽB
		    status = TERMINATED;
		}
		if (!interrupted && selectedAlt == null) {
		    // (ͥ)ѱ(ͥ)
		    if (!do_nothing_but_close_when_normal_alternative_selected) {
			session.doShioriEvent("OnChoiceTimeout",new String[] {master_script});
		    }
		    status = DONE;
		}
		else {
		    // ǂꂩI΂ꂽB
		    String value = selectedAlt.getRefcon();
		    if (isURL(value)) {
			// URLJB
			//try{ NSWorkspace.sharedWorkspace().openURL(new URL(value)); }catch(Exception e){}
			// URLȂalternativeSelectedJĂB
		    }
		    else {
			if (!do_nothing_but_close_when_normal_alternative_selected) {
			    session.doShioriEvent("OnChoiceSelect",new String[] {value});
			}
		    }
		    status = DONE;
		}
		
		//selectedAlt = session.getHontaiBalloon().alternativeTask(!session.isInPassiveMode());
		//status = DONE;
		cleanUp(true);
		NSAutoreleasePool.pop(pool);
		return;
	    }
	    
	    // 莞ԌoĂEChEB̊ԂɃC^vgꂽ瑦ɏIB
	    // EGCgɂ͑Oƌ㔼AO͕K҂Ȃ΂ȂȂ㔼̓C^vgŃJbgĂǂB
	    try {
		sleep(1500);
	    }
	    catch (InterruptedException e) {
		status = TERMINATED;
		cleanUp(false);
		NSAutoreleasePool.pop(pool);
		return;
	    }
	    
	    interrupt_forbidden = false;
	    status = DONE;

	    if (!isInterrupted()) {
		try {
		    sleep(6000);
		}
		catch (InterruptedException e) {
		    cleanUp(false);
		    NSAutoreleasePool.pop(pool);
		    return;
		}
	    }
	}
	
	cleanUp(true);
	NSAutoreleasePool.pop(pool);
    } // public void run()
    private void cleanUp(boolean hideBalloons) {
	// hideBalloons͖Btruełfalseło[͉BB
	
	//sendSurfaceRestoreEvent();
	session.getHontaiBalloon().cleanUp();
	session.getHontaiBalloon().makeSSTPMsgEmpty();
	session.getUnyuuBalloon().cleanUp();
	session.getUnyuuBalloon().makeSSTPMsgEmpty();
	if (changedBalloon) {
	    session.getHontaiBalloon().setType(0);
	    session.getUnyuuBalloon().setType(0);
	    session.recalcBalloonsLoc();
	}
	//if (hideBalloons)
	//{
	session.getHontaiBalloon().hide();
	session.getUnyuuBalloon().hide();
	//}
	
	// sessionCg[hŋNĂA
	// ŃVF\ƂB
	if (session.isLightMode()) {
	    session.getSakura().hide();
	    session.getKero().hide();
	}

	if (unselected_urls != null) {
	    unselected_urls.clear();
	}
	
	session = null;

	// Logger.log(this, Logger.DEBUG, "cleaned up");
    }

    public static boolean isURL(String str) {
	return str.startsWith("http://");
    }
    
    public void alternativeSelected(SCBalloonAlternative alt) {
	// SCSafetyBalloonControllerĂԃ\bhB
	// II΂ꂽB

	// ̑IURLłAI΂ĂȂURLIɂȂA
	// URLJJđIȂɂB
	// Ƀ^CAEg܂ł̕b𑝂₷B
	if (isURL(alt.getRefcon())) {
	    try {
		NSWorkspace.sharedWorkspace().openURL(new URL(alt.getRefcon()));
	    } catch (Exception e) {}
	    
	    unselected_urls.remove(alt);
	    if (!unselected_urls.isEmpty()) {
		alternative_timeout_sec += DEFAULT_ALTERNATIVE_TIMEOUT_SEC;
		return;
	    }
	}
	
	selectedAlt = alt;
	interrupt();

	//session.clearQueue();
    }
    
    public void anchorSelected(SCBalloonAlternative anchor) {
	// SCSafetyBalloonControllerĂԃ\bhB
	// AJ[I΂ꂽB
	session.doShioriEvent("OnAnchorSelect",new String[] {anchor.getRefcon()});
	interrupt();

	//session.clearQueue();
    }
    
    protected void doReturn(StringBuffer script) throws SCScriptErrorException,InterruptedException
    {
		String code; // \n  \u0002
		if (script.length() >= 3 && script.charAt(2) == '[') // tL
		{
			int blockstart = 2;
			int blockend = script.toString().indexOf(']',blockstart);
			
			if (blockend == -1)
			{
				throw new SCScriptErrorException("Illegal return symbol \u00a5n[] : missing ']'.");
			}
	    
			String enn_arg = script.substring(blockstart+1,blockend);
			if (enn_arg.equals("half"))
			{
				code = "\u0002";
			}
			else if (enn_arg.equals(""))
			{
				code = "\n";
			}
			else
			{
				warning("Undefined return symbol \u00a5n[] parameter : \""+enn_arg+"\".");
				code = "\n";
			}
			script.delete(0,blockend+1); // \n[]
		}
		else
		{
			code = "\n";
			script.delete(0,2); // \n̓񕶎B
		}
		
		if (synchronizedsession)
		{
			//session.getHontaiBalloon().show();
			//session.getUnyuuBalloon().show();
			session.getHontaiBalloon().addText(code,0);
			session.getUnyuuBalloon().addText(code,0);
		}
		else
		{
			SCSafetyBalloonController bc = (scope == 0 ? session.getHontaiBalloon() : session.getUnyuuBalloon());
			//bc.show();
			bc.addText(code,0);
		}
    }
    
    protected void executeSerikoSequence(StringBuffer script) throws SCScriptErrorException
    {
		if (script.length() < 3)
		{
			throw new SCScriptErrorException("Illegal SERIKO sequence execution command \u00a5i[] : missing '['.");
		}
		
		int blockstart = 2;
		if (script.charAt(blockstart) != '[')
		{
			throw new SCScriptErrorException("Illegal SERIKO sequence execution command \u00a5i[] : missing '['.");
		}
		
		int blockend = script.toString().indexOf(']');
		if (blockend == -1)
		{
			throw new SCScriptErrorException("Illegal SERIKO sequence execution command \u00a5i[] : missing ']'.");
		}
		
		String content = script.substring(blockstart+1,blockend);
		int id;
		try
		{
			id = Integer.parseInt(content);
		}
		catch (NumberFormatException e)
		{
			throw new SCScriptErrorException("Illegal SERIKO sequence execution command \u00a5i[] : parameter \""+content+"\" was not a number.");
		}
		session.getCurrentShell().getSeriko().execute(id,scope == 0);
		
		script.delete(0,blockend+1);
    }
    
    protected void doSurfaceChanging(StringBuffer script) throws SCScriptErrorException {
	if (script.length() < 3) {
	    throw new SCScriptErrorException("Illegal surface changing symbol \u00a5s[] or \u00a5s? : missing parameter.");
	}
	
	int id;
	
	if (script.charAt(2) == '[') { // ʌ^Ȃ
	    int blockstart = 2;
	    int blockend = script.toString().indexOf(']');
	    if (blockend == -1) {
		throw new SCScriptErrorException("Illegal surface changing symbol \u00a5s[] : missing ']'.");
	    }
	    String content = script.substring(blockstart+1,blockend);
	    
	    // \s[]̒\GXP[vȂǍs킯Ȃ̂ŁAGXP[v͏ȗB
	    // ܂̓GCAXl[e[uEĂ݂B
	    id = session.getCurrentShell().getAliasNameTable().lookup(
		scope == 0 ? "sakura.surface.alias" : "kero.surface.alias",
		content);
	    if (id == -1) { // e[uɒ`
		try {
		    id = Integer.parseInt(content); // lƌȂ
		}
		catch (NumberFormatException e) {
		    throw new SCScriptErrorException("Illegal surface changing symbol \u00a5s[] : parameter \""+content+"\" was neither defined as an alias nor a number.");
		}
	    }
	    
	    script.delete(0,blockend+1);
	}
	else {
	    String param = ""+script.charAt(2);
	    try {
		id = Integer.parseInt(param);
	    }
	    catch (NumberFormatException e) {
		throw new SCScriptErrorException("Illegal surface changing symbol \u00a5s? : parameter \""+param+"\" was not a number.");
	    }
	    script.delete(0,3); // s?̎OB
	}
	
	/*if (id == -1) {
	  SCShellWindowController swc = (scope == 0 ? session.getHontai() : session.getUnyuu());
	  swc.hide();
	  }
	else {*/
	SCShellWindowController swc = (scope == 0 ? session.getHontai() : session.getUnyuu());
	session.changeSurface(id,scope == 0);
	swc.show();
	//}
	
	if (scope == 0) {
	    sakura_yen_s_used = true;
	}
	else {
	    kero_yen_s_used = true;
	}
    }
    
    protected void doWaitCommand(StringBuffer script) throws SCScriptErrorException,InterruptedException {
	if (script.length() < 3) {
	    throw new SCScriptErrorException("Illegal wait symbol \u00a5w? : missing parameter.");
	}
	
	int param;
	try {
	    param = Integer.parseInt(""+script.charAt(2));
	}
	catch (NumberFormatException e) {
	    throw new SCScriptErrorException("Illegal wait symbol \u00a5w? : parameter \""+script.charAt(2)+"\" was not a number.");
	}

	session.getHontaiBalloon().flushWindow();
	session.getKeroBalloon().flushWindow();
	
	// 50{ăEGCgBspeed_upȂ猸B
	// Ɋݒ̃EFCg{B
	sleep((long)(param * 50 * (speed_up ? speed_up_ratio : 1) * wait_ratio));
	
	script.delete(0,3); // \w?̎OB
    }
    
    protected void doBalloonChanging(StringBuffer script) throws SCScriptErrorException
    {
		if (script.length() < 3)
		{
			throw new SCScriptErrorException("Illegal balloon changing symbol \u00a5b[] or \u00a5b? : missing parameter.");
		}
		
		int id;
		if (script.charAt(2) == '[') // ʌ^Ȃ
		{
			int blockstart = 2;
			int blockend = script.toString().indexOf(']');
			if (blockend == -1)
			{
				throw new SCScriptErrorException("Illegal balloon changing symbol \u00a5b[] : missing ']'.");
			}
			String content = script.substring(blockstart+1,blockend);
	    
			// \b[]̒\GXP[vȂǍs킯Ȃ̂ŁAGXP[v͏ȗB
			try
			{
				id = Integer.parseInt(content);
			}
			catch (NumberFormatException e)
			{
				throw new SCScriptErrorException("Illegal balloon changing symbol \u00a5b[] : parameter \""+content+"\" was not a number.");
			}
	    
			script.delete(0,blockend+1);
		}
		else
		{
			String param = ""+script.charAt(2);
			try
			{
				id = Integer.parseInt(param);
			}
			catch (NumberFormatException e)
			{
				throw new SCScriptErrorException("Illegal balloon changing symbol \u00a5b? : parameter \""+param+"\" was not a number.");
			}
			script.delete(0,3); // b?̎OB
		}
		
		if (id >= 0)
		{
			SCSafetyBalloonController bc = (scope == 0 ? session.getHontaiBalloon() : session.getUnyuuBalloon());
			bc.setType(id);
			session.recalcBalloonsLoc();
			changedBalloon = true;
		}
		else if (id == -1) // hide
		{
			SCSafetyBalloonController bc = (scope == 0 ? session.getHontaiBalloon() : session.getUnyuuBalloon());
			bc.hide();
		}
    }
    
    protected void doUniversalJumpCommand(StringBuffer script) throws SCScriptErrorException
    {
		if (script.length() < 3)
		{
			throw new SCScriptErrorException("Illegal universal jump symbol \u00a5j[] : missing '['.");
		}
		
		int blockstart = 2;
		if (script.charAt(blockstart) != '[')
		{
			throw new SCScriptErrorException("Illegal universal jump symbol \u00a5j[] : missing '['.");
		}
		int blockend = findCharWithoutEscape(script.toString(),']',3); // Sڂʂ̃T[`JnB
		if (blockend == -1)
		{
			throw new SCScriptErrorException("Illegal universal jump symbol \u00a5j[] : missing ']'.");
		}
		String content = script.substring(blockstart+1,blockend);
	
	
		if (content.startsWith("http://"))
		{
			// w肳ꂽURLJB
			try
			{
				NSWorkspace.sharedWorkspace().openURL(new URL(content));
			}
			catch(Exception e)
			{
				throw new SCScriptErrorException("Couldn't open the specified url "+content+" because of "+e.toString());
			}
		}
		else
		{
			/*********** deprecated ***********/
		}
	
		script.delete(0,blockend+1);
    }

    protected String escapeCommaInDoubleQuotation(String src)
    {
		StringBuffer result = new StringBuffer();
		
		boolean in_quote = false;
		int len = src.length();
		for (int i = 0;i < len;i++)
		{
			char c = src.charAt(i);
			if (c == '"')
			{
				in_quote = !in_quote;
			}
			else if (c == ',')
			{
				if (in_quote)
				{
					result.append("###_COMMA_###");
				}
				else
				{
					result.append(c);
				}
			}
			else
			{
				result.append(c);
			}
		}
	
		return result.toString();
    }
    protected String unescapeComma(String src)
    {
		StringBuffer buf = new StringBuffer(src);
		int pos;
		while ((pos = buf.toString().indexOf("###_COMMA_###")) != -1)
		{
			buf.replace(pos,pos+13,",");
		}
		return buf.toString();
    }
    protected void executeUniversalCommand(StringBuffer script) throws SCScriptErrorException,Exception
    {
		if (script.length() < 3)
		{
			throw new SCScriptErrorException("Illegal universal command symbol \u00a5![] : missing parameter.");
		}
		
		int blockstart = 2;
		if (script.charAt(blockstart) != '[')
		{
			throw new SCScriptErrorException("Illegal universal command symbol \u00a5![] : missing '['.");
		}
	
		int blockend = findCharWithoutEscape(script.toString(),']',3);
		if (blockend == -1)
		{
			throw new SCScriptErrorException("Illegal universal command symbol \u00a5![] : missing ']'.");
		}
	
		// _uNH[gɈ͂܂ꂽJ}GXP[vB
		String content = escapeCommaInDoubleQuotation(script.substring(blockstart+1,blockend));
		script.delete(0,blockend+1);
		
		StringTokenizer st = new StringTokenizer(content,",");
		String command = st.nextToken();
		Vector argv = new Vector();
		while (st.hasMoreTokens())
		{
			argv.add(unescapeComma(st.nextToken()));
		}
		executeUniversalCommand(command,argv);
    }
    protected void executeUniversalCommand(String command,Vector argv) throws SCScriptErrorException,Exception
    {
		// e\bhO͂̂܂܌ĂяoɃ_CNg܂B
		try
		{
			Method method = this.getClass().getMethod("univcommand_"+command,new Class[] {Vector.class});
			method.invoke(this,new Object[] {argv});
		}
		catch (NoSuchMethodException e)
		{
			warning("Undefined command of universal command symbol \u00a5![] : "+command);
		}
		catch (Exception e)
		{
			throw e;
		}
    }
    public void univcommand_enter(Vector argv) throws SCScriptErrorException
    {
		// passivemode
		if (argv.size() == 0)
		{
			throw new SCScriptErrorException("Illegal \u00a5![enter,#id#] command : missing parameter id.");
		}
		
		String arg1 = (String)argv.elementAt(0);
		if (arg1.equals("passivemode"))
		{
			if (argv.size() > 1)
			{
				warning("Illegal \u00a5![enter,passivemode] command : too many paramters.");
			}
			
			session.setPassiveMode(true);
		}
		else
		{
			warning("Undefined parameter id of \u00a5![enter,#id#] command : "+arg1);
		}
    }
    public void univcommand_leave(Vector argv) throws SCScriptErrorException
    {
		// passivemode
		if (argv.size() == 0)
		{
			throw new SCScriptErrorException("Illegal \u00a5![leave,#id#] command : missing parameter id.");
		}
		
		String arg1 = (String)argv.elementAt(0);
		if (arg1.equals("passivemode"))
		{
			if (argv.size() > 1)
			{
				warning("Illegal \u00a5![leave,passivemode] command : too many paramters.");
			}
			
			session.setPassiveMode(false);
		}
		else
		{
			warning("Undefined parameter id of \u00a5![leave,#id#] command : "+arg1);
		}
    }
    public void univcommand_lock(Vector argv) throws SCScriptErrorException
    {
		// repaint
    }
    public void univcommand_unlock(Vector argv) throws SCScriptErrorException
    {
		// repaint
    }
    public void univcommand_open(Vector argv) throws SCScriptErrorException
    {
		// inputbox,symbol,limittime
		// browser,url
		// mailer,address
		// teachbox
		// communicatebox
		if (argv.size() == 0)
		{
			throw new SCScriptErrorException("Illegal \u00a5![open,#object#] command : missing parameter object.");
		}
		
		String arg1 = (String)argv.elementAt(0);
		if (arg1.equals("browser"))
		{
			if (argv.size() < 2)
			{
				throw new SCScriptErrorException("Illegal \u00a5![open,browser,url] command : missing parameter url.");
			}
			else if (argv.size() > 2)
			{
				warning("Illegal \u00a5![open,browser,url] command : too many paramters.");
			}
			
			String arg2 = (String)argv.elementAt(1);
			// w肳ꂽURLJB
			try
			{
				NSWorkspace.sharedWorkspace().openURL(new URL(arg2));
			}
			catch(Exception e)
			{
				throw new SCScriptErrorException("Couldn't open the specified url "+arg2+" because of "+e.toString());
			}
		}
		else if (arg1.equals("teachbox"))
		{
			if (argv.size() > 1)
			{
				warning("Illegal \u00a5![open,teachbox] command : too many paramters.");
			}
			
			session.doTeach();
		}
		else if (arg1.equals("communicatebox"))
		{
			if (argv.size() > 1)
			{
				warning("Illegal \u00a5![open,communicatebox] command : too many paramters.");
			}
			
			session.showCommunicateBox();
		}
		else if (arg1.equals("inputbox"))
		{
			if (argv.size() < 2)
			{
				warning("Illegal \u00a5![open,inputbox,#symbol#,#timeout#] command : missing parameter event.");
			}
			
			String symbol = (String)argv.elementAt(1);
			int timeout = -1;
			if (argv.size() > 3)
				timeout = Integer.parseInt((String)argv.elementAt(2));
			session.startInputBoxSession(symbol,timeout);
		}
    }
    public void univcommand_raise(Vector argv) throws SCScriptErrorException
	{
		if (argv.size() == 0)
		{
			throw new SCScriptErrorException("Illegal \u00a5![raise,#name#,#ref0#,#ref1#,...] command : missing parameter name.");
		}
		
		String eventName = (String)argv.elementAt(0);
		
		final int n_refs = argv.size()-1;
		String[] refs = new String[n_refs];
		for (int i = 0;i < n_refs;i++)
		{
			refs[i] = (String)argv.elementAt(i+1);
		}
		
		session.doShioriEvent(eventName,refs);
    }
    
    protected void doStrictWaitCommand(StringBuffer script) throws SCScriptErrorException,InterruptedException {
	if (script.length() < 4) {
	    throw new SCScriptErrorException("Illegal strict wait symbol \u00a5_w[] : missing '['.");
	}
	
	int blockstart = 3;
	if (script.charAt(blockstart) != '[') {
	    throw new SCScriptErrorException("Illegal strict wait symbol \u00a5_w[] : missing '['.");
	}
	int blockend = script.toString().indexOf(']');
	if (blockend == -1) {
	    throw new SCScriptErrorException("Illegal strict wait symbol \u00a5_w[] : missing ']'.");
	}
	String content = script.substring(blockstart+1,blockend);
	
	int waitparam;
	try {
	    waitparam = Integer.parseInt(content);
	}
	catch (NumberFormatException e) {
	    throw new SCScriptErrorException("Illegal strict wait symbol \u00a5_w[] : parameter \""+content+"\" was not a number.");
	}
	if (waitparam < 0) {
	    throw new SCScriptErrorException("Illegal strict wait symbol \u00a5_w[] : parameter \""+content+"\" was negative.");
	}

	session.getHontaiBalloon().flushWindow();
	session.getKeroBalloon().flushWindow();
	
	sleep((long)(waitparam * (speed_up ? speed_up_ratio : 1) * wait_ratio));
	
	script.delete(0,blockend+1);
    }
    
    protected void doAsciiCodeImplantation(StringBuffer script) throws SCScriptErrorException
    {
		if (script.length() < 4)
		{
			throw new SCScriptErrorException("Illegal ascii code implantation symbol \u00a5_m[] : missing '['.");
		}
		
		int blockstart = 3;
		if (script.charAt(blockstart) != '[')
		{
			throw new SCScriptErrorException("Illegal ascii code implantation symbol \u00a5_m[] : missing '['.");
		}
		int blockend = script.toString().indexOf(']');
		if (blockend == -1)
		{
			throw new SCScriptErrorException("Illegal ascii code implantation symbol \u00a5_m[] : missing ']'.");
		}
		String content = script.substring(blockstart+1,blockend);
		
		// 0x[0-9a-fA-F]{2}̌`ɂȂĂ邩ǂ`FbN
		if (content.length() != 4 || !content.startsWith("0x"))
		{
			throw new SCScriptErrorException("Illegal ascii code implantation symbol \u00a5_m[] : format error in parameter \""+content+"\". It has to be 0x[0-9a-fA-F]{2} in regex for example 0x2a.");
		}
		
		String result;
		try
		{
			int code = Integer.parseInt(content.substring(2),16); // 0x̎
			char c = (char)(code & 0x00ff);
			result = ""+c;
		}
		catch (NumberFormatException e)
		{
			throw new SCScriptErrorException("Illegal ascii code implantation symbol \u00a5_m[] : parameter \""+content+"\" was not a hex number.");
		}
		
		script.replace(0,blockend+1,result);
    }
    
    protected void doUCS2CodeImplantation(StringBuffer script) throws SCScriptErrorException
    {
		if (script.length() < 4)
		{
			throw new SCScriptErrorException("Illegal UCS-2 code implantation symbol \u00a5_u[] : missing '['.");
		}
		
		int blockstart = 3;
		if (script.charAt(blockstart) != '[')
		{
			throw new SCScriptErrorException("Illegal UCS-2 code implantation symbol \u00a5_u[] : missing '['.");
		}
		int blockend = script.toString().indexOf(']');
		if (blockend == -1)
		{
			throw new SCScriptErrorException("Illegal UCS-2 code implantation symbol \u00a5_u[] : missing ']'.");
		}
		String content = script.substring(blockstart+1,blockend);
	
		// 0x[0-9a-fA-F]{4}̌`ɂȂĂ邩ǂ`FbN
		if (content.length() != 6 || !content.startsWith("0x"))
		{
			throw new SCScriptErrorException("Illegal UCS-2 code implantation symbol \u00a5_u[] : format error in parameter \""+content+"\". It has to be 0x[0-9a-fA-F]{4} in regex for example 0x00b2.");
		}
		
		String result;
		try
		{
			int code = Integer.parseInt(content.substring(2),16); // 0x̎
			char c = (char)(code & 0xffff);
			result = ""+c;
		}
		catch (NumberFormatException e)
		{
			throw new SCScriptErrorException("Illegal UCS-2 code implantation symbol \u00a5_u[] : parameter \""+content+"\" was not a hex number.");
		}
	
		script.replace(0,blockend+1,result);
    }
	
    protected void doPuttingAnchor(StringBuffer script) throws SCScriptErrorException {
	if (script.length() < 4){
	    throw new SCScriptErrorException("Illegal anchor definition symbol \u00a5_a[]...\u00a5_a : missing '['.");
	}
	
	int blockstart = 3;
	if (script.charAt(blockstart) != '[') {
	    throw new SCScriptErrorException("Illegal anchor definition symbol \u00a5_a[]...\u00a5_a : missing '['.");
	}
	int blockend = findCharWithoutEscape(script.toString(),']',4); // 5ڂʂ̃T[`JnB
	if (blockend == -1) {
	    throw new SCScriptErrorException("Illegal anchor definition symbol \u00a5_a[]...\u00a5_a : missing ']'.");
	}
	String anchor_id = script.substring(blockstart+1,blockend);
	
	// AJ[I^O\_aTB
	int end_tag_pos = script.toString().indexOf("\u00a5_a",blockend+1);
	if (end_tag_pos == -1) {
	    throw new SCScriptErrorException("Illegal anchor definition symbol \u00a5_a[]...\u00a5_a : missing end-symbol \u00a5_a.");
	}
	String anchor_title = script.substring(blockend+1,end_tag_pos);
	
	script.delete(0,end_tag_pos+3);
	
	SCSafetyBalloonController balloon = (scope == 0 ? session.getSakuraBalloon() : session.getKeroBalloon());
	SCShellWindowController swc = (scope == 0 ? session.getSakura() : session.getKero());
	
	balloon.show();
	swc.show();
	
	balloon.addAnchor(anchor_title,anchor_id);
    }
    
    protected void doShioriCommunicateImplantation(StringBuffer script) throws SCScriptErrorException
    {
		if (script.length() < 4)
		{
			throw new SCScriptErrorException("Illegal SHIORI communicate implantation symbol \u00a5_c[] : missing '['.");
		}
		
		int blockstart = 3;
		if (script.charAt(blockstart) != '[')
		{
			throw new SCScriptErrorException("Illegal SHIORI communicate implantation symbol \u00a5_c[] : missing '['.");
		}
		int blockend = findCharWithoutEscape(script.toString(),']',4); // 5ڂʂ̃T[`JnB
		if (blockend == -1)
		{
			throw new SCScriptErrorException("Illegal SHIORI communicate implantation symbol \u00a5_c[] : missing ']'.");
		}
		
		// SHIORI/3.0ł͔p~ꂽ͗lB
		if (session.getMasterSpirit().getShioriProtocolVersion() != 2)
		{
			script.delete(0,blockend+1);
		}
		else
		{
			String content = script.substring(blockstart+1,blockend);
			
			StringBuffer buf = new StringBuffer("GET Sentence SHIORI/2.0\r\n");
			buf.append("Sender: "+SCFoundation.STRING_FOR_SENDER+"\r\n");
			buf.append("Sentence: "+content+"\r\n");
			buf.append("\r\n"); // NGXg
			SCShioriSessionResponce resp = session.getMasterSpirit().doShioriSession(buf.toString());
			String responce = (String)resp.getResponce().get("Sentence");
			
			String translated = (responce == null ? "" : session.getMasterSpirit().translateWithShiori(responce));
			script.replace(0,blockend+1,session.getMasterSpirit().translateWithMakoto(translated));
		}
    }
    
    protected void doBalloonImageCommand(StringBuffer script) throws SCScriptErrorException {
        if(script.length() < 4) {
            throw new SCScriptErrorException("Illegal balloon image \u00a5_b[s,x,y] : missing parameter.");
        }
        
        int blockstart = 3;
        int blockend = findCharWithoutEscape(script.toString(),']',4); // \_b[s,x,y]^Cv
        if (blockend == -1) {
            throw new SCScriptErrorException("Illegal balloon image \u00a5_b[s,x,y] : missing ']'.");
        }
        String content = script.substring(blockstart+1,blockend);
        
        int comma_pos1 = content.indexOf(',',0);
        if (comma_pos1 == -1) {
            throw new SCScriptErrorException("Illegal balloon image \u00a5_b[s,x,y] : missing ','.");
        }
        String imageFile = content.substring(0,comma_pos1);
        
        int comma_pos2 = content.indexOf(',',comma_pos1+1);
	if (comma_pos1 == -1) {
            throw new SCScriptErrorException("Illegal balloon image \u00a5_b[s,x,y] : missing ','.");
        }
        String sx = content.substring(comma_pos1+1,comma_pos2);
        String sy = content.substring(comma_pos2+1);
        
        script.delete(0,blockend+1);
        
        // REDFLAG: x,y  centerx,centery Z^[|Cg擾BB
	if (sx.equals("centerx") || sy.equals("centery")) {
	    System.err.println("SCScriptRunner: centerx/centery used in \u00a5_b tag. This is unimplemented yet.");
	    sx = sy = "0";
	}
        
	SCSafetyBalloonController bc =
	    scope == 0 ? session.getHontaiBalloon() : session.getUnyuuBalloon();
	bc.addImage(imageFile,Integer.parseInt(sx),Integer.parseInt(sy));
    }

    protected void doPuttingAlternativeCommand(StringBuffer script) throws SCScriptErrorException {
	if (script.length() < 3) {
	    throw new SCScriptErrorException(
		"Illegal putting alternative symbol \u00a5q?[id][title] or \u00a5q[title,id] : missing parameter.");
	}
	
	String title,id;
	if (script.charAt(2) == '[') { // \q[title,id]^Cv
	    int blockstart = 2;
	    int blockend = findCharWithoutEscape(script.toString(),']',3); // 4ڂʂ̃T[`JnB
	    if (blockend == -1) {
		throw new SCScriptErrorException("Illegal putting alternative symbol \u00a5q[title,id] : missing ']'.");
	    }
	    String content = script.substring(blockstart+1,blockend);
	    
	    int comma_pos = content.indexOf(',');
	    if (comma_pos == -1) {
		throw new SCScriptErrorException("Illegal putting alternative symbol \u00a5q[title,id] : missing ','.");
	    }
	    
	    title = content.substring(0,comma_pos);
	    id = content.substring(comma_pos+1);
	    
	    script.delete(0,blockend+1); // ʂ܂łB
	}
	else { // \q?[id][title]^Cv
	    if (!Character.isDigit(script.charAt(2))) {
		throw new SCScriptErrorException(
		    "Illegal putting alternative symbol \u00a5q?[id][title] :"+
		    " missing index number. This is not important at all but illegal format.");
	    }
	    
	    int blockstart,blockend;
	    
	    blockstart = 3;
	    if (script.charAt(blockstart) != '[') {
		throw new SCScriptErrorException(
		    "Illegal putting alternative symbol \u00a5q?[id][title] : missing '[' of [id].");
	    }
	    blockend = findCharWithoutEscape(script.toString(),']',4);
	    if (blockend == -1) {
		throw new SCScriptErrorException(
		    "Illegal putting alternative symbol \u00a5q?[id][title] : missing ']' of [id].");
	    }
	    id = script.substring(blockstart+1,blockend);
	    
	    blockstart = blockend+1;
	    if (script.charAt(blockstart) != '[') {
		throw new SCScriptErrorException(
		    "Illegal putting alternative symbol \u00a5q?[id][title] : missing '[' of [title].");
	    }
	    blockend = findCharWithoutEscape(script.toString(),']',blockstart+1); // [id]̎̎̕ʂ̃T[`JnB
	    if (blockend == -1) {
		throw new SCScriptErrorException(
		    "Illegal putting alternative symbol \u00a5q?[id][title] : missing ']' of [title].");
	    }
	    title = script.substring(blockstart+1,blockend);
	    
	    script.replace(0,blockend+1,"\u00a5n"); // ʂ܂ł\nB
	}
	
	SCSafetyBalloonController balloon = (scope == 0 ? session.getSakuraBalloon() : session.getKeroBalloon());
	SCShellWindowController swc = (scope == 0 ? session.getSakura() : session.getKero());
	
	balloon.show();
	swc.show();
	
	SCBalloonAlternative alt = balloon.addAlternative(title,id);
	hasAlternative = true; // IL
	interrupt_forbidden = true; // ÎŃ^CNeBJZbVɋڍsB

	if (isURL(id)) {
	    // c[`bvtB
	    alt.setToolTip(id);
	    
	    if (unselected_urls == null) {
		unselected_urls = Collections.synchronizedSet(new HashSet());
	    }
	    unselected_urls.add(alt);
	}
    }
    
    protected void doHandlerImplantation(StringBuffer script) throws SCScriptErrorException
    {
		if (script.length() < 3)
		{
			throw new SCScriptErrorException("Illegal handler implantation symbol %j[] : missing '['.");
		}
		
		int blockstart = 2;
		if (script.charAt(blockstart)!= '[')
		{
			throw new SCScriptErrorException("Illegal handler implantation symbol %j[] : missing '['.");
		}
		int blockend = findCharWithoutEscape(script.toString(),']',3);
		if (blockend == -1)
		{
			throw new SCScriptErrorException("Illegal handler implantation symbol %j[] : missing ']'.");
		}
			
		/*************** deprecated *************/
		script.delete(0,blockend+1);
    }
    
    protected void warning(String msg)
    {
		System.err.println("SCScriptRunner WARNING "+msg);
    }
    
    
    public int findCharWithoutEscape(String src,char chr,int startpos)
    {
		return findCharWithoutEscape(src,chr,startpos,'\u00a5');
    }
    public int findCharWithoutEscape(String src,char chr,int startpos,char escape)
    {
		// srcstartpos(0IW)chrTAchrescapeŃGXP[vĂ玟chrTB
		// ǌtȂ-1ԂB
		int len = src.length();
		int pos = startpos;
		while (pos < len)
		{
			if (src.charAt(pos) == chr && !(pos > 0 && src.charAt(pos-1) == escape))
			{
				return pos;
			}
			pos++;
		}
		return -1;
    }
    
    public boolean interruptAllowed() {
	if (status != RUNNING && status != SCRIPT_END) {
	    return true;
	}
	else {
	    return !interrupt_forbidden;
	}
    }
    
    public int getStatus()
    {
		return status;
    }
    
    public boolean hasAlternative()
    {
		// IR}hł]ꂽ炳ꂽtrueɂȂ܂B
		// i[쐬_ł͏falseł邱ƂɒӂĉB
		return hasAlternative;
    }
    
    public SCBalloonAlternative getSelectedAlternative()
    {
		// ܂II΂ÓAnullԂ܂B
		return selectedAlt;
    }
    
    public void terminate() {
	if (!isAlive()) return;
	
	interrupt();
        while(isAlive()) {
	    try {
		Thread.sleep(100);
	    }
	    catch (Exception e) {}
	}
    }
	
	public void speedUp()
	{
		speed_up = true;
	}
	
	public void speedDown()
	{
		speed_up = false;
	}
    
    private void sendSurfaceRestoreEvent() {
	if (session.getHontai().currentSurfaceId() != 0 || session.getUnyuu().currentSurfaceId() != 10) {
	    /*session.doShioriEvent("OnSurfaceRestore",new String[] {
	      Integer.toString(session.getHontai().currentSurfaceId()),
	      Integer.toString(session.getUnyuu().currentSurfaceId())
	      } );*/
	    session.changeSurface(0,true);
	    session.changeSurface(10,false);
	}
    }
    
    public static void setWaitRatio(double ratio) {
	wait_ratio = ratio;
    }

    protected void finalize() {
	//Logger.log(this, Logger.DEBUG, "finalized");
    }

    public String toString() {
	StringBuffer buf = new StringBuffer();
	buf.append("session: {").append(session).append('}');
	//buf.append("; script: ").append(master_script);
	if (interrupt_forbidden) {
	    buf.append("; interrupt forbidden");
	}
	buf.append("; status: ");
	if (status == RUNNING) {
	    buf.append("running");
	}
	else if (status == SCRIPT_END) {
	    buf.append("script-end");
	}
	else if (status == DONE) {
	    buf.append("done");
	}
	else if (status == TERMINATED) {
	    buf.append("terminated");
	}
	else {
	    buf.append("*unknown*");
	}
	if (hasAlternative) {
	    buf.append("; has alternative");
	}
	if (selectedAlt != null) {
	    buf.append("; selected alt: {").append(selectedAlt).append('}');
	}
	return buf.toString();
    }
}
