/*  $Id: SaoriResponce.java,v 1.2 2004/01/29 12:14:45 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package satori.saori;
import satori.*;
import satori.saori.*;
import java.util.*;

public class SaoriResponce {
    public static final SaoriResponce EMPTY = new SaoriResponce("");
    
    String main_result;
    Vector sub_results; // <String>
    
    public SaoriResponce(String main_result) {
	this.main_result = main_result;
	this.sub_results = new Vector();
    }
    
    public SaoriResponce(String main_result,Vector sub_results) {
	this.main_result = main_result;
	this.sub_results = (Vector)sub_results.clone();
    }
    
    public String getMainResult() {
	return main_result;
    }
    
    public Vector getSubResults() {
	return sub_results;
    }
}
