/*
  $Id: DGPLoader.java,v 1.1 2003/06/14 13:27:30 phonohawk Exp $
  ----------
  
  "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
  Copyright (C) 2001 phonohawk
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package util;
import util.DGPDecodingStream;
import java.io.*;
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class DGPLoader {
    public static NSImage load(File dgp_file) {
	// 植݂ɎsꍇnullԂB
	try {
	    InputStream is = new DGPDecodingStream(
		new FileInputStream(dgp_file),dgp_file.getName());
	    ByteArrayOutputStream baos = new ByteArrayOutputStream();

	    byte[] buf = new byte[512];
	    while (true) {
		int n = is.read(buf);
		if (n == -1) {
		    // EOF
		    break;
		}
		baos.write(buf,0,n);
	    }

	    is.close();
	    baos.close();

	    return new NSImage(new NSData(baos.toByteArray()));
	}
	catch (Exception e) {
	    return null;
	}
    }
}