/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

public class SCESArgumentsTokenizer
{
    StringBuffer buf;
    String delm;
    
    public SCESArgumentsTokenizer(String str,String delm)
    {
	buf = new StringBuffer(str);
	this.delm = delm;
    }
    
    public boolean hasMoreTokens()
    {
	return buf.length() > 0;
    }
    
    public String nextToken()
    {
	if (buf.length() == 0) return null; // 
	
	boolean in_quote = false;
	for (int i = 0;i < buf.length();i++)
	{
	    if (buf.charAt(i) == '\"')
	    {
		in_quote = !in_quote;
	    }
	    else if (delm.indexOf(buf.charAt(i)) != -1 && !in_quote) // f~^
	    {
		String token = buf.substring(0,i);
		buf.delete(0,i+1);
		return token;
	    }
	}
	
	// Ō̃g[N
	String token = buf.toString();
	buf.setLength(0);
	return token;
    }
}
