/*
	$Id: SCErrorStringServer.java,v 1.2 2002/12/08 16:10:04 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCErrorStringServer
{
    static String getErrorMessage(String label)
    {
		// Ȃ烉x̂̂Ԃ܂B
		return NSBundle.mainBundle().localizedStringForKey(label,label,"ErrorDic");
    }
    
    static String getErrorMessage(String label,String[] params)
    {
		// f[^x[X̃bZ[WɊ܂܂Ă#1A#2Ƃp[^Œu܂B
		// #1A͂܂B
		// Ȃ烉x̂̂Ԃ܂B
		StringBuffer buf = new StringBuffer( NSBundle.mainBundle().localizedStringForKey(label,label,"ErrorDic") );
		
		for (int i = 0;i < params.length;i++)
		{
			String meta = "#" + (i + 1);
			
			while(true) // ԍŉxłuB
				{
				int blockstart = buf.toString().indexOf(meta);
				int blockend = blockstart + meta.length();
				if (blockstart == -1) break;
				
				buf.replace(blockstart,blockend,params[i]);
			}
		}
		
		return buf.toString();
    }
}
