/*
	$Id: SCGhostThumbnailMover.java,v 1.2 2002/12/08 16:10:04 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;

public class SCGhostThumbnailMover
{
    public static void moveAll()
    {
		String bundleDir = SCFoundation.sharedFoundation().getParentDirOfBundle();
		
		File home_ghost = new File(bundleDir,"home/ghost");
		File[] ghosts = home_ghost.listFiles();
		for (int i = 0;i < ghosts.length;i++)
		{
			if (!ghosts[i].isDirectory()) continue;
			
			File thumbnail = new File(ghosts[i],"ghost/master/thumbnail.png");
			if (thumbnail.exists())
			{
				File newplace = new File(ghosts[i],"thumbnail.png");
				thumbnail.renameTo(newplace);
			}
		}
    }
}
