/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import java.util.*;

public class SCKawariResponce
{
    Vector keywords; // gStringB
    String script;
    
    public SCKawariResponce(String line)
    {
	// ["keyword1","keyword",...] : SCRIPT
	// ̌`ł邱Ƃۏ؂ĂKv܂B
	keywords = new Vector();
	
	
	script = SCKawariDictionary.escapeQuoted(line.substring(line.indexOf(':')+1).trim()); // NH[g͈͂̓GXP[vB
	
	String keywordsStr = line.substring(0,line.indexOf(':')).trim(); // keywordsStr[]ň͂܂ĂB
	keywordsStr = SCKawariDictionary.escapeQuoted( keywordsStr ); // NH[ǵ͈i܂L[[hjGXP[vĂB""͏B
	StringTokenizer st = new StringTokenizer(keywordsStr.substring(1,keywordsStr.length()-1),","); // []͊O
	while (st.hasMoreTokens())
	{
	    String keyword = SCKawariDictionary.unescape( (String)st.nextToken().trim() );
	    // AGXP[vēo^BŃL[[hɔpJ}gB
	    
	    keywords.add(keyword);
	}
    }
    
    public boolean match(String sentence)
    {
	int n_keywords = keywords.size();
	for (int i = 0;i < n_keywords;i++)
	{
	    if (sentence.indexOf( (String)keywords.elementAt(i) ) == -1) // ̃L[[hZeX̉ɂ܂܂ĂȂ
	    {
		return false;
	    }
	}
	return true;
    }
    
    public String script()
    {
	return script;
    }
}
