/*  $Id: SCMakotoAccessor.java,v 1.3 2004/01/02 11:28:41 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2003 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.lang.reflect.*;

/*
    request()\bh͌_łString󂯎StringԂ\bĥ݃T|[gĂ܂A
    KvLΗႦInputStreamOutputStream󂯎艽returnŕԂȂ\bhIɒ`
    I[o[[h邱Ƃo܂B
*/

public class SCMakotoAccessor
{
    Object module; // MAKOTOW[NX{
    
    Method string_getModuleName; // public String getModuleName()
    Method string_request_string; // public String request(String req) -- _łrequest͂̃^Cv̂݃T|[gB
    Method void_terminate; // public void terminate()
    
    public SCMakotoAccessor(Object module) throws Exception {
	this.module = module;
	
	Class mod_class = module.getClass();
	string_getModuleName = mod_class.getMethod("getModuleName",null);
	string_request_string = mod_class.getMethod("request",new Class[] {String.class});
	try {
	    void_terminate = mod_class.getMethod("terminate",null);
	}
	catch (NoSuchMethodException e) { // ȗĂB
	    void_terminate = null;
	}
    }
    
    public String getModuleName() {
	try {
	    return (String)string_getModuleName.invoke(module,null);
	}
	catch (Exception e) { e.printStackTrace(); return null; }
    }
    
    public String request(String req) {
	try {
	    return (String)string_request_string.invoke(module,new Object[] {req});
	}
	catch (Exception e) { e.printStackTrace(); return null; }
    }
    
    public void terminate() {
	if (void_terminate == null) return;
	
	try {
	    void_terminate.invoke(module,null);
	}
	catch (Exception e) { e.printStackTrace(); }

	module = null;
	string_getModuleName = null;
	string_request_string = null;
	void_terminate = null;
    }

    public String toString() {
	return "core: "+module;
    }
}
