/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;

public class SCNSResourceEntries
{
    Hashtable table; // key : (String)ID , value : (Vector)strings
    // (Vector)strings ; value : (String)string
    
    public SCNSResourceEntries()
    {
	table = new Hashtable();
    }
    
    public void addEntry(String id,String value)
    {
	Vector strings = (Vector)table.get(id);
	if (strings == null)
	{
	    strings = new Vector();
	    table.put(id,strings);
	}
	
	strings.add(value);
    }
    
    public Vector findEntries(String id)
    {
	return (Vector)table.get(id);
    }
}
