/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import com.apple.cocoa.foundation._private.*;

public class SCNoiseImageGenerator
{
    protected static SCNoiseImageGenerator_Impl implimentation;
    protected static NSObjectiveCSelector sel_scramble;
    static
    {
	implimentation = new SCNoiseImageGenerator_Impl(); // shared object
	sel_scramble = new NSObjectiveCSelector("scramble:");
    }
    
    public static void scramble(NSImage image)
    {
	try
	{
	    sel_scramble.invoke(implimentation,new Object[] {image});
	}
	catch (Exception e)
	{
	    System.err.println("SCNoiseImageGenerator : Couldn\'t call the obj-c method scramble:");
	    e.printStackTrace();
	}
    }
}
