/*  $Id: SCSSTPDaemon.java,v 1.4 2003/12/24 06:02:13 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.net.*;
import java.io.*;

public class SCSSTPDaemon extends Thread {
    ServerSocket ss;
    boolean signal_stop;
    
    public SCSSTPDaemon(int port) {
        try {
	    ss = new ServerSocket(port);
        }
        catch(IOException e) {
	    ss = null; // IĂȂBgpsB
        }
        signal_stop = false;
	
	try {
	    SCPrefWindowController prefwindow = SCPrefWindowController.sharedPrefWindowController();
	    prefwindow.addStringToSSTPLog("### sstpd started listening at port "+port+" of "+InetAddress.getLocalHost().toString()+" ###\n\n");
	} catch(Exception e) {}
    }
    
    public void run() {
        if (ss == null) return;
	int pool = NSAutoreleasePool.push();
        
        while(!signal_stop) {
            try {
                ss.setSoTimeout(2 * 1000); // b[
                Socket s = ss.accept();
                
                // phase 0.8̎dςłB
                // ƂT[rXXbhɋNĂԂƂĂ
                // SEND SSTP/*̎sŃ^CNeBJZbVɓĂԂłȂ
                // ڑ󂯂܂܂B
                // ̓ł́AႦSHIORIVXenhɂă^CNeBJZbV
                // ĂɁASSTPɐڑĂȂĂ409 ConflictɂȂĂ܂܂A
                // ̖͌قǉƎv܂B
		int inner_pool = NSAutoreleasePool.push();
		
                SCPrefWindowController prefwindow = SCPrefWindowController.sharedPrefWindowController();
                prefwindow.addStringToSSTPLog("# connected from "+s.getInetAddress().toString()+'\n');
                
                SCServerServiceThread sst = new SCServerServiceThread(s);
                sst.start();

		NSAutoreleasePool.pop(inner_pool);
            }
            catch (Exception e) {
                continue;
            }
        }
        
        try{  ss.close();  }catch(Exception e){}
        
        SCPrefWindowController prefwindow = SCPrefWindowController.sharedPrefWindowController();
        prefwindow.addStringToSSTPLog("### sstpd stopped ###\n\n");
	
	NSAutoreleasePool.pop(pool);
    }
    
    public void terminate() {
        // KĂłB
        // sstpd̃Xbh̒Ă񂾂肵Ă͂܂B
        if (ss == null) return;
        signal_stop = true;
        while (isAlive()) {}
    }
}
