/*
	$Id: SCTeachBoxController.java,v 1.2 2002/12/08 16:10:07 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCTeachBoxController extends NSWindowController
{
    NSTextField textfield;
    
    SCTeachSession teach;
    SCSession session;
    
    public SCTeachBoxController(SCTeachSession teach)
    {
		super("TeachBox");
		this.teach = teach;
		session = teach.getSession();
		
		window();
		window().setTitle("TEACH : "+session.getSelfName());
    }
    
    public void showWindow(Object sender)
    {
		// \ׂʒuvZB
		// {̃VF̍COM{bNX̍킹邪A؂̖ʒu܂ł炵ďCB
		final int screenWidth = (int)NSScreen.mainScreen().frame().width();
		final int shellLeft = (int)session.getHontai().x();
		final int shellTop = (int)session.getHontai().height();
		int teachboxLeft = shellLeft;
		int teachboxBottom = shellTop;
		if (teachboxLeft < 0)
		{
			teachboxLeft = 0;
		}
		else if (teachboxLeft + window().frame().width() > screenWidth)
		{
			teachboxLeft = screenWidth - (int)window().frame().width();
		}
		window().setFrameOrigin(new NSPoint(teachboxLeft,teachboxBottom));
		super.showWindow(sender);
    }
    
    public void show()
    {
		if (window().isVisible()) return;
		
			//windowCtrl.showWindow(null);
		NSTimer open_timer = new NSTimer(
					0.0,
					this,
					new NSSelector("showWindow",new Class[] {NSNull.class}),
					new Object[] {NSNull.nullValue()},
					false);
		SCFoundation.sharedFoundation().getRunLoopOfMainThread().addTimerForMode(open_timer,NSRunLoop.DefaultRunLoopMode);
		if (!Thread.currentThread().getName().equals("main")) while (!window().isVisible()) {} // ҋ@
    }
    
    public void close(Object sender)
    {
		window().orderOut(sender);
    }
    
    public void send(Object sender)
    {
		if (textfield.stringValue().length() == 0) return;
		
		teach.messageFromUser(textfield.stringValue());
		textfield.setStringValue("");
    }
}
